# 💥 LapisDB

[![star this repo](http://githubbadges.com/star.svg?user=kekland&repo=lapisdb&style=flat)](https://github.com/kekland/lapisdb)
[![fork this repo](http://githubbadges.com/fork.svg?user=kekland&repo=lapisdb&style=flat)](https://github.com/kekland/lapisdb/fork)
[![License](https://img.shields.io/github/license/kekland/lapisdb.svg)](https://github.com/kekland/lapisdb)
[![Version](https://img.shields.io/npm/v/lapisdb.svg)](https://www.npmjs.com/package/lapisdb)
[![Downloads](https://img.shields.io/npm/dt/lapisdb.svg)](https://www.npmjs.com/package/lapisdb)
[![Status](https://travis-ci.org/kekland/lapisdb.svg?branch=master)](https://travis-ci.org/kekland/lapisdb)

A **TypeScript** embedded database built on top of [LevelDB](https://github.com/level/level) - a fast and efficient C++ database.

## ❗ Attention

I am still working on this project, and many things **might change in future**.

## 💾 Installation

[**Download via NPM**](https://https://www.npmjs.com/package/lapisdb)

```bash
cd my-awesome-project
npm install --save lapisdb
```

## ❓ Why in the world do I need another database?

During my experience writing **backend services**, I often cannot find a database that is both **fast** and **easy** to use.

**LapisDB** is fully typed and uses **TypeScript** under the hood to make the development process a blast.

## 🔨 How do I use it?

### 📕 Documentation

You can find the full **TypeDoc documentation** [here](https://kekland.github.io/lapisdb).

### 📋 Tutorial

Check out the **GitHub Wiki** page [here](https://github.com/kekland/lapisdb/wiki).

### Additional features

*Coming soon*: hooks, validation, etc.

## 📧 Contact me

**E-Mail**: `kk.erzhan@gmail.com`
