"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ValueStream {
    constructor(stream) {
        this.closed = false;
        this._stream = stream;
        this._stream.on('data', (data) => {
            if (this._onData) {
                let passed = true;
                if (this._middleware) {
                    passed = this._middleware(data);
                }
                if (passed) {
                    this._onData(data);
                }
            }
        });
        this._stream.on('close', () => {
            this.closed = true;
            if (this._onClose) {
                this._onClose();
            }
            if (this._internalOnClose) {
                this._internalOnClose();
            }
        });
    }
    set onData(value) {
        this._onData = value;
    }
    set onError(value) {
        this._onError = value;
    }
    set onClose(value) {
        this._onClose = value;
    }
    set middleware(value) {
        this._middleware = value;
    }
    untilEnd() {
        return new Promise((resolve, reject) => {
            if (this.closed) {
                return;
            }
            this._internalOnClose = () => {
                resolve();
            };
        });
    }
}
exports.ValueStream = ValueStream;
//# sourceMappingURL=value.stream.js.map