import { Datastore } from '../datastore/datastore';
export interface IObjectMetadata {
    id: string;
    created?: number;
    updated?: number;
}
export declare class Model<T extends Model<T>> {
    meta: IObjectMetadata;
    private store;
    constructor(data?: {
        id?: string;
        store?: Datastore<T>;
    });
    setData(data: {
        id: string;
        store: Datastore<T>;
    }): void;
    setCreatedTime(time: number): void;
    setUpdatedTime(time: number): void;
    setDb(store: Datastore<T>): void;
    save(): Promise<void>;
    delete(): void;
    log(func: (any: any) => void): void;
}
