import { Model } from "../model/model";
import { BaseOperation } from "./database.operations";
import { Datastore } from "../datastore/datastore";
export declare class DeleteOperation<T extends Model<T>> implements BaseOperation<T> {
    private _store;
    private _id;
    constructor(store: Datastore<T>, id?: string);
    item(item: T): this;
    id(id: string): this;
    run(): Promise<void>;
    delete(): Promise<void>;
}
export declare class BatchedDeleteOperation<T extends Model<T>> implements BaseOperation<T> {
    private _store;
    private _identifiers;
    constructor(store: Datastore<T>);
    item(item: T): this;
    items(items: T[]): this;
    id(id: string): this;
    ids(ids: string[]): this;
    identifiers(ids: string[]): this;
    run(): Promise<void>;
    delete(): Promise<void>;
}
