"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class EditOperation {
    constructor(store, id, item) {
        this._store = store;
        this._id = id;
        this._item = item;
    }
    item(item) {
        this._item = item;
        return this;
    }
    id(id) {
        this._id = id;
        return this;
    }
    with(data) {
        this._data = data;
        return this;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.edit();
        });
    }
    edit() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._item == null) {
                if (this._id == null) {
                    throw new Error('Invalid parameters for EditOperation.');
                }
                this._item = yield this._store.methods.getOne(this._id);
            }
            if (this._data == null) {
                throw new Error('Invalid parameters for EditOperation.');
            }
            for (const key in this._data) {
                if (this._data[key] != null && key != 'meta' && key != 'db') {
                    this._item[key] = this._data[key];
                }
            }
            yield this._store.methods.put(this._item.meta.id, this._item);
            return this._item;
        });
    }
}
exports.EditOperation = EditOperation;
//# sourceMappingURL=edit.operation.js.map