import { BaseOperation } from "./database.operations";
import { PaginationData, Datastore } from "../datastore/datastore";
import { ISort } from "../sort/sort.types";
import { IFilter } from "../filter/filter.types";
import { Model } from "../model/model";
export declare class GetOperation<T extends Model<T>> implements BaseOperation<T> {
    private _filter;
    private _pagination;
    private _sort;
    private store;
    constructor(store: Datastore<T>);
    where(method: (value: IFilter<T>) => boolean): GetOperation<T>;
    filter(method: (value: IFilter<T>) => boolean): GetOperation<T>;
    id(id: string): GetOperation<T>;
    orderBy(data: ISort<T>): GetOperation<T>;
    sort(data: ISort<T>): GetOperation<T>;
    paginate(data: PaginationData): GetOperation<T>;
    skip(skip: number): GetOperation<T>;
    take(take: number): GetOperation<T>;
    run(): Promise<T[]>;
    result(): Promise<T[]>;
    first(): Promise<T>;
    last(): Promise<T>;
    count(): Promise<number>;
}
