import { BaseOperation } from "./database.operations";
import { Datastore } from "../datastore/datastore";
import { Model } from "../model/model";
export declare class PushOperation<T extends Model<T>> implements BaseOperation<T> {
    private _toAdd;
    private _store;
    constructor(store: Datastore<T>);
    item(value: T): this;
    run(): Promise<T>;
    push(): Promise<T>;
}
export declare class BatchedPushOperation<T extends Model<T>> implements BaseOperation<T> {
    private _store;
    private _toAdd;
    constructor(store: Datastore<T>);
    item(value: T): this;
    items(values: T[]): this;
    run(): Promise<T[]>;
    push(): Promise<T[]>;
}
