"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SortOperator {
    constructor(sort) {
        this.sort = sort;
    }
    isFieldFunction(field) {
        return typeof field == 'function';
    }
    run(values) {
        return values.sort((a, b) => {
            let results = new Map();
            for (const sortKey in this.sort) {
                const sortWith = this.sort[sortKey];
                const aField = a[sortKey];
                const bField = b[sortKey];
                let priority = 0;
                let result = 0;
                if (this.isFieldFunction(sortWith.sort)) {
                    result = sortWith.sort(aField, bField);
                }
                else {
                    result = (aField > bField ? 1 : (aField < bField) ? -1 : 0) * sortWith.sort;
                }
                if (sortWith.priority) {
                    priority = sortWith.priority;
                }
                const arr = results.get(priority);
                if (arr) {
                    results.set(priority, [result, ...arr]);
                }
                else {
                    results.set(priority, [result]);
                }
            }
            const priorities = results.keys();
            let prioritiesArray = [];
            for (const priority of priorities) {
                prioritiesArray.push(priority);
            }
            prioritiesArray.sort((a, b) => b - a);
            for (const priority of prioritiesArray) {
                const resultsArray = results.get(priority);
                for (const result of resultsArray) {
                    if (result != 0) {
                        return result;
                    }
                }
            }
            return 0;
        });
    }
}
exports.SortOperator = SortOperator;
//# sourceMappingURL=sort.js.map