"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('Callback', () => {
    it('for onPush', () => __awaiter(this, void 0, void 0, function* () {
        let receivedPushData = null;
        index_test_config_1.testStore.onPush((data) => {
            receivedPushData = data;
        });
        const newPlanet = yield index_test_config_1.testStore.push().item(new index_test_config_1.Planet('a', 0)).run();
        expect(newPlanet).toEqual(receivedPushData);
    }));
    it('for onEdit', () => __awaiter(this, void 0, void 0, function* () {
        let receivedEditData = null;
        index_test_config_1.testStore.onEdit((id, data) => {
            receivedEditData = data;
        });
        const newPlanet = yield index_test_config_1.testStore.push().item(new index_test_config_1.Planet('a', 0)).run();
        const editedPlanet = yield index_test_config_1.testStore.edit().item(newPlanet).with({ index: 1 }).run();
        expect(editedPlanet).toEqual(receivedEditData);
    }));
    it('for onDelete', () => __awaiter(this, void 0, void 0, function* () {
        let receivedDeleteData = null;
        index_test_config_1.testStore.onDelete((data) => {
            receivedDeleteData = data;
        });
        const newPlanet = yield index_test_config_1.testStore.push().item(new index_test_config_1.Planet('a', 0)).run();
        yield index_test_config_1.testStore.delete().item(newPlanet).run();
        expect(newPlanet.meta.id).toEqual(receivedDeleteData);
    }));
});
//# sourceMappingURL=callback.test.js.map