"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('DELETE operation', () => {
    describe('deletes', () => {
        describe('single object', () => {
            it('via item', () => __awaiter(this, void 0, void 0, function* () {
                const item = new index_test_config_1.Planet('pluto', 0);
                yield index_test_config_1.testStore.push().item(item).run();
                yield index_test_config_1.testStore.delete().item(item).run();
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toBe(0);
            }));
            it('via id', () => __awaiter(this, void 0, void 0, function* () {
                const item = new index_test_config_1.Planet('pluto', 0);
                yield index_test_config_1.testStore.push().item(item).run();
                yield index_test_config_1.testStore.delete().id(item.meta.id).run();
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toBe(0);
            }));
        });
        describe('single object through shorthand method', () => {
            it('via item', () => __awaiter(this, void 0, void 0, function* () {
                const item = new index_test_config_1.Planet('pluto', 0);
                yield index_test_config_1.testStore.push().item(item).run();
                yield index_test_config_1.testStore.deleteItem(item);
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toBe(0);
            }));
            it('via id', () => __awaiter(this, void 0, void 0, function* () {
                const item = new index_test_config_1.Planet('pluto', 0);
                yield index_test_config_1.testStore.push().item(item).run();
                yield index_test_config_1.testStore.deleteItem(item.meta.id);
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toBe(0);
            }));
        });
        describe('batched', () => {
            describe('single object', () => {
                it.todo('via item');
                it.todo('via id');
            });
            describe('multiple object', () => {
                it.todo('via item');
                it.todo('via id');
            });
        });
    });
});
//# sourceMappingURL=delete.operation.test.js.map