"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('EDIT operation', () => {
    describe('edits', () => {
        it('via item', () => __awaiter(this, void 0, void 0, function* () {
            const item = new index_test_config_1.Planet('pluto', 0);
            yield index_test_config_1.testStore.push().item(item).run();
            yield index_test_config_1.testStore.edit().item(item).with({ name: 'mars' }).run();
            const newItem = yield index_test_config_1.testStore.get().first();
            expect(newItem.name).toBe('mars');
        }));
        it('via id', () => __awaiter(this, void 0, void 0, function* () {
            let item = new index_test_config_1.Planet('pluto', 0);
            item = yield index_test_config_1.testStore.push().item(item).run();
            yield index_test_config_1.testStore.edit().id(item.meta.id).with({ name: 'mars' }).run();
            const newItem = yield index_test_config_1.testStore.get().first();
            expect(newItem.name).toBe('mars');
        }));
    });
    describe('edits through shorthand method', () => {
        it('via item', () => __awaiter(this, void 0, void 0, function* () {
            const item = new index_test_config_1.Planet('pluto', 0);
            yield index_test_config_1.testStore.push().item(item).run();
            yield index_test_config_1.testStore.editItem(item, { name: 'mars' });
            const newItem = yield index_test_config_1.testStore.get().first();
            expect(newItem.name).toBe('mars');
        }));
        it('via id', () => __awaiter(this, void 0, void 0, function* () {
            let item = new index_test_config_1.Planet('pluto', 0);
            item = yield index_test_config_1.testStore.push().item(item).run();
            yield index_test_config_1.testStore.editItem(item.meta.id, { name: 'mars' });
            const newItem = yield index_test_config_1.testStore.get().first();
            expect(newItem.name).toBe('mars');
        }));
    });
});
//# sourceMappingURL=edit.operation.test.js.map