"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('PUSH operation', () => {
    describe('adds', () => {
        it('single element', () => __awaiter(this, void 0, void 0, function* () {
            const planet = new index_test_config_1.Planet('planet', 0);
            yield index_test_config_1.testStore.push().item(planet).run();
            const count = yield index_test_config_1.testStore.get().count();
            expect(count).toEqual(1);
        }));
        it('single element via shorthand method', () => __awaiter(this, void 0, void 0, function* () {
            const planet = new index_test_config_1.Planet('planet', 0);
            yield index_test_config_1.testStore.pushItem(planet);
            const count = yield index_test_config_1.testStore.get().count();
            expect(count).toEqual(1);
        }));
        it('five elements', () => __awaiter(this, void 0, void 0, function* () {
            for (let i = 0; i < 5; i++) {
                const planet = new index_test_config_1.Planet('planet', i);
                yield index_test_config_1.testStore.push().item(planet).run();
            }
            const count = yield index_test_config_1.testStore.get().count();
            expect(count).toEqual(5);
        }));
        describe('batched', () => {
            it('single element', () => __awaiter(this, void 0, void 0, function* () {
                const planet = new index_test_config_1.Planet('planet', 0);
                yield index_test_config_1.testStore.pushBatched().item(planet).run();
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toEqual(1);
            }));
            it('five elements', () => __awaiter(this, void 0, void 0, function* () {
                const operation = index_test_config_1.testStore.pushBatched();
                for (let i = 0; i < 5; i++) {
                    const planet = new index_test_config_1.Planet('planet', i);
                    operation.item(planet);
                }
                yield operation.run();
                const count = yield index_test_config_1.testStore.get().count();
                expect(count).toEqual(5);
            }));
        });
    });
});
//# sourceMappingURL=push.operation.test.js.map