"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_test_config_1 = require("../../index.test.config");
describe('Validation', () => {
    describe('during pushing', () => {
        it('should catch invalid item', () => __awaiter(this, void 0, void 0, function* () {
            try {
                const newPlanet = yield index_test_config_1.testStore.pushItem(new index_test_config_1.Planet('a', -1));
                throw { message: 'Validation let through invalid item', code: 1 };
            }
            catch (e) {
                if (e.code === 1) {
                    throw e;
                }
                return true;
            }
        }));
        it('should let through valid item', () => __awaiter(this, void 0, void 0, function* () {
            try {
                const newPlanet = yield index_test_config_1.testStore.pushItem(new index_test_config_1.Planet('a', 0));
                return true;
            }
            catch (e) {
                throw e;
            }
        }));
    });
    describe('during editing', () => {
        it('should catch invalid item', () => __awaiter(this, void 0, void 0, function* () {
            try {
                const planet = yield index_test_config_1.testStore.pushItem(new index_test_config_1.Planet('a', 0));
                const editedPlanet = yield index_test_config_1.testStore.editItem(planet, { index: -1 });
                throw { message: 'Validation let through invalid item', code: 1 };
            }
            catch (e) {
                if (e.code === 1) {
                    throw e;
                }
                return true;
            }
        }));
        it('should let through valid item', () => __awaiter(this, void 0, void 0, function* () {
            try {
                const planet = yield index_test_config_1.testStore.pushItem(new index_test_config_1.Planet('a', 0));
                const editedPlanet = yield index_test_config_1.testStore.editItem(planet, { index: 1 });
                return true;
            }
            catch (e) {
                throw e;
            }
        }));
    });
});
//# sourceMappingURL=validation.test.js.map