"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const class_validator_1 = require("class-validator");
class Human {
    constructor(name, age) {
        this.name = name;
        this.age = age;
    }
}
exports.Human = Human;
class Planet extends _1.Model {
    constructor(name, index) {
        super();
        this.name = name;
        this.index = index;
        this.people = [];
    }
    addHuman() {
        this.people.push(new Human(`Citizen of planet ${this.name} number ${this.people.length + 1}`, 0));
    }
    age() {
        this.people.forEach(human => human.age += 1);
    }
}
__decorate([
    class_validator_1.IsNotEmpty(),
    __metadata("design:type", String)
], Planet.prototype, "name", void 0);
__decorate([
    class_validator_1.Min(0),
    __metadata("design:type", Number)
], Planet.prototype, "index", void 0);
exports.Planet = Planet;
exports.testStore = null;
beforeEach(() => __awaiter(this, void 0, void 0, function* () {
    exports.testStore = new _1.Datastore('test', './database', () => Planet, true);
    const items = yield exports.testStore.get().result();
    yield exports.testStore.deleteBatched().items(items).run();
}));
afterEach(() => __awaiter(this, void 0, void 0, function* () {
    yield exports.testStore.methods.store.close();
}));
exports.testCreateRandomPlanets = (push = false) => __awaiter(this, void 0, void 0, function* () {
    const data = [];
    for (let i = 0; i < 100; i++) {
        data.push(new Planet(`Planet ${i}`, i));
    }
    if (push) {
        yield exports.testStore.pushBatched().items(data).run();
    }
    return data;
});
//# sourceMappingURL=index.test.config.js.map